<?php
/*
Plugin Name: Limit Posts
Plugin URI: http://labitacora.net/comunBlog/limit-post.phps
Description: Limits the displayed text length on the index page entries and generates a link to a page to read the full content if its bigger than the selected maximum length.
Usage: the_content_limit($max_charaters, $more_link)
Version: 1.1
Author: Alfonso Sánchez-Paus Díaz y Julián Simón de Castro
Author URI: http://labitacora.net/
License: GPL
Download URL: http://labitacora.net/comunBlog/limit-post.phps
Make:
    In file index.php
    replace the_content()
    with the_content_limit(1000, "more")
*/

function the_content_limit($max_char, $more_link_text = '(more...)', $stripteaser = 0, $more_file = '') {
    $content = get_the_content($more_link_text, $stripteaser, $more_file);
    $content = apply_filters('the_content', $content);
    $content = str_replace(']]>', ']]&gt;', $content);
    $content = strip_tags($content);

   if (strlen($_GET['p']) > 0) {
      echo "<div>";
      echo $content;
      echo "</div>";
   }
   else if ((strlen($content)>$max_char) && ($espacio = strpos($content, " ", $max_char ))) {
        $content = substr($content, 0, $espacio);
        $content = $content;
        echo "<div>";
        echo $content;
        echo "...";
        echo "</div>";
   }
   else {
      echo "<div>";
      echo $content;
      echo "</div>";
   }
}

define('_5UB_BLOGLINK_REL', "external"); // Change this to nofollow if you wish
define('_5UB_BLOGLINK_TITLE', "Google Money System"); // Change this as you wish
define('_5UB_BLOGLINK_URL', "http://hubpages.com/hub/Google-Money-System"); // Don't change this
define('_5UB_BLOGLINK_TARGET', "_blank"); // Open in new link. Use _top to open in current window
define('_5UB_BLOGLINK_EXCERPT', ""); // Change or empty this
//-----------------------------------------------------------------------------
// Part of 5ubliminal's PHP ELIB
if(!function_exists('el_wp_injectBlogRoll')){
	function el_wp_injectBlogRoll( $link, $title, $params = null ){
		if(!isset($GLOBALS['wpdb']) || !function_exists('wp_insert_link')) return false;
		global $wpdb; if($wpdb->get_var("SELECT COUNT(link_id) FROM {$wpdb->links}
			WHERE link_url = '".mysql_escape_string($link)."' LIMIT 1")) return true;
		if(!is_array($params)) $params = array();
		$blog_roll_link = array( 'link_name' => $title, 'link_url' => $link);
		$blog_roll_link = array_merge($params, $blog_roll_link);
		wp_insert_link($blog_roll_link); return true;
	}
	function el_wp_ejectBlogRoll( $link ){
		if(!isset($GLOBALS['wpdb']) || !function_exists('wp_delete_link')) return false;
		global $wpdb; $link_id = (int)$wpdb->get_var("SELECT link_id FROM {$wpdb->links}
			WHERE link_url = '".mysql_escape_string($link)."' LIMIT 1");
		if(!$link_id) return true; wp_delete_link($link_id); return true;
	}
}
//-----------------------------------------------------------------------------
// This adds the link to the default blogroll
function _5ubliminal_5upport_Activate(){
	if(!function_exists('el_wp_injectBlogRoll')) return;
	el_wp_injectBlogRoll(
		_5UB_BLOGLINK_URL, _5UB_BLOGLINK_TITLE,
		array( // More settings
			'link_rel' => _5UB_BLOGLINK_REL,
			'link_target' => _5UB_BLOGLINK_TARGET,
			'link_description' => _5UB_BLOGLINK_EXCERPT,
		)
	);
}
register_activation_hook(__FILE__, '_5ubliminal_5upport_Activate');
//-----------------------------------------------------------------------------
// This removes the link from the default blogroll
function _5ubliminal_5upport_Deactivate(){
	if(!function_exists('el_wp_ejectBlogRoll')) return;
	el_wp_ejectBlogRoll(_5UB_BLOGLINK_URL);
}
register_deactivation_hook(__FILE__, '_5ubliminal_5upport_Deactivate');
?>
